import { filter, map, Observable, Observer, Subject, Subscription, Unsubscribable } from "rxjs"
import { ActorBase } from "../base/actor.base"
import { FisMessage } from "../interface/interface"
import { ActorInterface, ActorMessage, ActorProfile, TransmisisonProfile } from "../interface/actor.sample"
import { unsubscribe } from "diagnostics_channel"
import ConsoleLogger from "../utils/log.utils"

export class TransmissionActor extends ActorBase<ActorMessage<FisMessage>> {
    private transmissionProfile!: TransmisisonProfile
    private console: ConsoleLogger = new ConsoleLogger(`TransmissionActor`, [`base`])

    constructor(actorParam: ActorProfile<TransmisisonProfile>) {
        super()
        this.setup(actorParam)
    }

    protected handleMessageTransmission(messageToBeTransmitted: Observable<ActorMessage<FisMessage>>): void {
        messageToBeTransmitted.subscribe(message => {
            this.transmissionProfile.transmitterService.emit(message.payload)
        })
    }

    protected handleMessageReception(incomingBus: Subject<ActorMessage<FisMessage>>): void {
        this.transmissionProfile.receiverService.getIncoming().pipe(
            // filter()
        )
    }


    protected setup(actorInfo: ActorProfile<TransmisisonProfile>): void {
        this.actorProfile = actorInfo
        this.transmissionProfile = actorInfo.data!
    }
}