import { MessageTransmissionBase } from "../base/msg.transmission.base";
import { filter, Observable, Observer, Subject, Subscription, takeWhile } from "rxjs";
import { v4 as uuidv4 } from 'uuid'
import { MessageTransmissionReceiver } from "./msg.transmission.receiver";
import { MessageTransmissionTransmitter } from "./msg.transmission.transmitter";
import { AdapterInterface, FisMessage, GeneralEvent, MessageRequestResponseInterface } from "../interface/interface";

export class MessageTransmissionRequestResponse extends MessageTransmissionBase implements MessageRequestResponseInterface {
    transmitterInstance!: MessageTransmissionTransmitter;
    receiverInstance!: MessageTransmissionReceiver;

    constructor(transmitterInstance: MessageTransmissionTransmitter, receiverInstance: MessageTransmissionReceiver, event: Subject<GeneralEvent<any>>) {
        super()
        this.setTransmissionProfile(transmitterInstance, receiverInstance)
        this.event = event
    }

    setTransmissionProfile(transmissionInfo: MessageTransmissionTransmitter, receiverInfo: MessageTransmissionReceiver): void {
        this.transmitterInstance = transmissionInfo
        this.receiverInstance = receiverInfo
    }

    // To be Enhanced. This is actually wrong at the moment
    send(message: FisMessage): Observable<FisMessage> {
        return new Observable((response: Observer<FisMessage>) => {
            // logic here
        });
    }

    setUpAdapter(adapter: AdapterInterface): void {
        // logic here
    }
}